/**
 * Created by GShark on 24.10.2014.
 */
import java.io.*;
import java.util.*;

public class TestGen {
    public static void main(String[] args) throws IOException {
        new TestGen().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    int tNumber;
    Random rnd;
    final int MAXN = 1_000_000_000;

    int rand(int n) {
        return rnd.nextInt(n);
    }

    void print(int n, int k) throws IOException {
        System.err.println(tNumber);
        if (tNumber < 10) {
            out = new PrintWriter("../tests/0" + tNumber);
        } else {
            out = new PrintWriter("../tests/" + tNumber);
        }
        tNumber++;
        out.println(n + " " + k);
        out.close();
    }


    // here starts gens

    void genSamples() throws IOException {
        print(1, 10);
        print(5, 1);
    }

    int genRandNum(int len, int d) {
        int step = 10;
        for (int i = 1; i < Math.min(len, 8); i++)
            step *= 10;
        int res = rand(step);
        return res * 10 + d;
    }

    void  genRandPack(int len) throws IOException {
        for (int i = 0; i < 10; i++)
            print(genRandNum(len, i), rand(MAXN / 2) + MAXN / 2 + 1);
    }

    void genMax() throws IOException {
        for (int i = 0; i < 10; i++)
            print(MAXN - i, MAXN);
    }

    void genSimples() throws IOException {
        print(0, MAXN);
        print(17, 0);
        print(55, 200);
    }

    //the end of the gens

    public void generate() throws IOException {
        new File("../tests").mkdir();
        tNumber = 1;
        rnd = new Random(388282447);
        genSamples();
        genSimples();
        for (int i = 1; i < 9; i += 2)
            genRandPack(i);
        genMax();
    }

    public void run() throws IOException {
        Locale.setDefault(Locale.US);
        generate();
    }
}
