/**
 * Created by GShark on 24.10.2014.
 */
import java.math.BigInteger;
import java.util.*;

import ru.ifmo.testlib.*;
import ru.ifmo.testlib.Outcome.Type;


public class Check implements Checker {

    int compare(StringBuilder a, StringBuilder b) {
        int i = 0;
        while (i < Math.min(a.length(), b.length()) && a.charAt(i) == b.charAt(i)) {
            i++;
        }
        if (i == a.length() && i == b.length()) {
            return 0;
        }
        if (i == a.length()) {
            return 1;
        }
        if (i == b.length()) {
            return -1;
        }
        if (a.charAt(i) > b.charAt(i)) {
            return 1;
        } else {
            return -1;
        }
    }

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt();
        StringBuilder jAns = new StringBuilder("");
        for (int i = 0; i < n; i++) {
            int a = ans.nextInt();
            jAns.append(String.valueOf(a));
        }
        //BigInteger jNum = new BigInteger(jAns.toString());
        TreeMap<Integer, Integer> input = new TreeMap<Integer, Integer>();
        for (int i = 0; i < n; i++) {
            int a = inf.nextInt();
            int g = 1;
            if (input.containsKey(a)) {
                g += input.remove(a);
            }
            input.put(a, g);
            //System.out.println(a + " " + (g + 1));
        }
        StringBuilder cAns = new StringBuilder("");
        for (int i = 0; i < n; i++) {
            int a = ouf.nextInt();
            if (!input.containsKey(a) || input.get(a) == 0) {
                return new Outcome(Type.WA, "Not in input contestant's number #" + (i + 1));
            }
            int g = input.remove(a);
            input.put(a, g - 1);
            cAns.append(String.valueOf(a));
        }
        //BigInteger cNum = new BigInteger(cAns.toString());
        if (!inf.seekEoF()) {
            return new Outcome(Type.WA, "too much tokens in answer");
        }
        if (compare(cAns, jAns) < 0) {
            return new Outcome(Type.WA, "Jury Answer is Bigger");
        }
        if (compare(cAns, jAns) == 0) {
            return new Outcome(Type.OK, "Jury has same answer");
        }
        if (compare(cAns, jAns) > 0) {
            return new Outcome(Type.FAIL, "Contestant anwer is better O_o");
        }
        return new Outcome(Type.FAIL, "");
    }
}
