/**
 * Created by GShark on 24.10.2014.
 */
import java.io.*;
import java.util.*;

public class TestGen {
    public static void main(String[] args) throws IOException {
        new TestGen().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    int tNumber;
    Random rnd;
    final int MAXN = 10_000;
    ArrayList<String> test;

    int rand(int n) {
        return rnd.nextInt(n);
    }

    void print(ArrayList<String> al) throws IOException {
        System.err.println(tNumber);
        if (tNumber < 10) {
            out = new PrintWriter("../tests/0" + tNumber);
        } else {
            out = new PrintWriter("../tests/" + tNumber);
        }
        tNumber++;
        out.println(al.size());
        for (int i = 0; i < al.size(); i++)
            out.println(al.get(i));
        al.clear();
        out.close();
    }


    // here starts gens

    void genSample1() throws IOException {
        test.add("W.W");
        test.add("C.C");
        test.add("WW.");
        test.add("CC.");
        test.add("CWW");
        print(test);
    }

    void genSample2() throws IOException {
        test.add("W.W");
        test.add("CWC");
        test.add("W.W");
        test.add("CWW");
        print(test);
    }

    void genSimple1() throws IOException {
        test.add("WWW");
        test.add("CWC");
        test.add("W.W");
        test.add("CWW");
        print(test);
    }

    void genSimple2() throws IOException {
        test.add("W.W");
        test.add("CW.");
        test.add("WW.");
        test.add("CCW");
        print(test);
    }

    char randChar() {
        int k = rand(3);
        if (k == 0) {
            return '.';
        } else if (k == 1) {
            return 'W';
        } else {
            return 'C';
        }
    }

    String randString() {
        String s = "";
        for (int i = 0; i < 3; i++) {
            s += randChar();
        }
        return s;
    }

    void genRand1(int n) throws IOException {
        for (int i = 0; i < n; i++) {
            test.add(randString());
        }
        print(test);
    }

    void genRand2(int n) throws IOException {
        String s = randString();
        while (s.equals("WWW")) {
            s = randString();
        }
        test.add(s);
        for (int i = 1; i < n; i++) {
            s = randString();
            while (s.equals("WWW")) {
                s = randString();
            }
            boolean flag = false;
            while (!flag) {
                String q = test.get(i - 1);
                for (int j = 0; j < 3; j++) {
                    for (int k = -1; k <= 1; k++) {
                        if (j + k >= 0 && j + k < 3) {
                            if (q.charAt(j) != 'W' && s.charAt(j + k) != 'W') {
                                flag = true;
                            }
                        }
                    }
                }
                s = "" + randChar() + randChar1() + randChar();
            }
            test.add(s);
        }
        print(test);
    }

    char randChar1() {
        int k = rand(2);
        if (k == 1) {
            return '.';
        } else {
            return 'C';
        }
    }

    void genSpecial1(int n) throws IOException {
        for (int i = 0; i < n; i++) {
            String s = "" + randChar1() + "W" +randChar1();
            test.add(s);
        }
        print(test);
    }

    void genSpecial2(int n) throws IOException {
        for (int i = 0; i < n; i++) {
            String s = "" + randChar() + "W" +randChar1();
            if (rand(2) == 0)
                s = "" + randChar1() + randChar() + randChar();
            test.add(s);
        }
        print(test);
    }

    //the end of the gens

    public void generate() throws IOException {
        new File("../tests").mkdir();
        tNumber = 1;
        rnd = new Random(388282447);
        test = new ArrayList<String>();
        genSample1();
        genSample2();
        genSimple1();
        genSimple2();
        for (int i = 10; i <= 100; i += 10) {
            int n = rand(i / 2) + i / 2 + 1;
            genRand1(n);
            n = rand(i / 2) + i / 2 + 1;
            genRand2(n);
            n = rand(i / 2) + i / 2 + 1;
            genSpecial1(n);
            n = rand(i / 2) + i / 2 + 1;
            genSpecial2(n);
        }
        for (int i = 0; i < 3; i++) {
            int n = rand(MAXN / 2) + MAXN / 2 + 1;
            genRand1(n);
            n = rand(MAXN / 2) + MAXN / 2 + 1;
            genRand2(n);
            n = rand(MAXN / 2) + MAXN / 2 + 1;
            genSpecial1(n);
            n = rand(MAXN / 2) + MAXN / 2 + 1;
            genSpecial2(n);
        }
        genRand1(MAXN);
        genRand2(MAXN);
        genSpecial1(MAXN);
        genSpecial2(MAXN);


    }

    public void run() throws IOException {
        Locale.setDefault(Locale.US);
        generate();
    }
}
