import java.io.*;
import java.util.*;

public class TestGen {

    static PrintWriter out;
    static Random rnd = new Random(0);
    static int tNumber;
    static void printTest(ArrayList<Character> s, ArrayList<ArrayList<Character> > c) throws IOException {
        if (tNumber < 10)
            out = new PrintWriter("../tests/0" + tNumber);
        else
            out = new PrintWriter("../tests/" + tNumber);
        tNumber++;
        out.println(s.size() + " " + c.size());
        for (int i = 0; i < s.size(); ++i)
        	out.print(s.get(i));
        out.println();
        for (int i = 0; i < c.size(); i++) {
        	for (int j = 0; j < c.get(i).size(); ++j)
        		out.print(c.get(i).get(j));
        	out.println();        
        }                       
        out.close();
    }
    static void genSample() throws FileNotFoundException {
        out = new PrintWriter("../tests/01");       
        out.println("12 3\r\ncabacaqwerty\r\nerty\r\ncaba\r\ncaqw");
        out.close();
    }
    static int randFromTo(int l, int r) {
        return rnd.nextInt(r - l + 1) + l;      
    }
    static ArrayList<Character> genStr(int len, int maxAl) {
    	ArrayList<Character> ans = new ArrayList();
    	for (int i = 0; i < len; i++)
    		ans.add(new Character((char)('a' + randFromTo(0, maxAl))));
    	return ans;    		 
    }
    static ArrayList<ArrayList<Character> > cutStr(ArrayList<Character> str, int len) {
    	ArrayList<ArrayList<Character> > ans = new ArrayList<ArrayList<Character> >();
    	for (int i = 0; i < str.size(); i += len) {
    		ArrayList<Character> now = new ArrayList<Character>();
    		for (int j = 0; j < len; j++)
    			now.add(str.get(i + j));
    		ans.add(now);
    	}
    	Collections.shuffle(ans);
    	return ans;
    }

    static void makeTest(int len, int maxAl) throws IOException {
    	ArrayList<Integer> tmp = new ArrayList();
    	for (int i = 2; i <= len; i++) {
    		if (len % i == 0)
    			tmp.add(i);		
    	}
    	int l = tmp.get(randFromTo(0, tmp.size() - 1));
		ArrayList<Character> s = genStr(len, maxAl);
		ArrayList<ArrayList<Character> > c = cutStr(s, l);
		printTest(s, c);
    }

    public static void main(String[] args) throws IOException {
        genSample();
        tNumber = 2;
        ArrayList tmp = genStr(1, 10);
        printTest(tmp, cutStr(tmp, 1));
        for (int i = 0; i < 5; i++)
        	makeTest(randFromTo(10, 100), 10);
		for (int i = 0; i < 5; i++)
        	makeTest(randFromTo(100, 1000), 25);
		for (int i = 0; i < 5; i++)
        	makeTest(randFromTo(1000, 10000), 25 - i);
        for (int i = 0; i < 5; i++)
        	makeTest(randFromTo(10000, 100000), 25 - i);
        for (int i = 0; i < 5; i++)
        	makeTest(randFromTo(100000, 1000000), 25);
        tmp = genStr(1000000, 10);
        printTest(tmp, cutStr(tmp, 1000000));                			        
        
    }
}
